Loading...
Searching...
No Matches
Opm::GasPvtThermal< Scalar > Class Template Reference

This class implements temperature dependence of the PVT properties of gas. More...

`#include <GasPvtThermal.hpp>`

## Public Types

using | IsothermalPvt = GasPvtMultiplexer<Scalar, false>
using | TabulatedOneDFunction = Tabulated1DFunction<Scalar>

## Public Member Functions

GasPvtThermal (IsothermalPvt *isothermalPvt, const std::vector< TabulatedOneDFunction > &gasvisctCurves, const std::vector< Scalar > &viscrefPress, const std::vector< Scalar > &viscRef, const std::vector< Scalar > &gasdentRefTemp, const std::vector< Scalar > &gasdentCT1, const std::vector< Scalar > &gasdentCT2, const std::vector< Scalar > &gasJTRefPres, const std::vector< Scalar > &gasJTC, const std::vector< TabulatedOneDFunction > &internalEnergyCurves, bool enableThermalDensity, bool enableJouleThomson, bool enableThermalViscosity, bool enableInternalEnergy)

| GasPvtThermal (const GasPvtThermal &data)
void | setNumRegions (std::size_t numRegions)
| Set the number of PVT-regions considered by this object.
void | setVapPars (const Scalar par1, const Scalar par2)
void | initEnd ()
| Finish initializing the thermal part of the gas phase PVT properties.
bool | enableThermalDensity () const
| Returns true iff the density of the gas phase is temperature dependent.
bool | enableJouleThomson () const
| Returns true iff Joule-Thomson effect for the gas phase is active.
bool | enableThermalViscosity () const
| Returns true iff the viscosity of the gas phase is temperature dependent.
std::size_t | numRegions () const
template<class Evaluation>
Evaluation | internalEnergy (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &Rv, const Evaluation &RvW) const
| Returns the specific internal energy [J/kg] of gas given a set of parameters.
template<class Evaluation>
Evaluation | viscosity (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &Rv, const Evaluation &Rvw) const
| Returns the dynamic viscosity [Pa s] of the fluid phase given a set of parameters.
template<class Evaluation>
Evaluation | saturatedViscosity (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure) const
| Returns the dynamic viscosity [Pa s] of the oil-saturated gas phase given a set of parameters.
template<class Evaluation>
Evaluation | inverseFormationVolumeFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &Rv, const Evaluation &) const
| Returns the formation volume factor [-] of the fluid phase.
template<class FluidState, class LhsEval = typename FluidState::Scalar>
std::pair< LhsEval, LhsEval > | inverseFormationVolumeFactorAndViscosity (const FluidState &fluidState, unsigned regionIdx)
| Returns the formation volume factor [-] and viscosity [Pa s] of the fluid phase.
template<class Evaluation>
Evaluation | saturatedInverseFormationVolumeFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure) const
| Returns the formation volume factor [-] of oil-saturated gas.
template<class Evaluation>
Evaluation | saturatedWaterVaporizationFactor (unsigned, const Evaluation &, const Evaluation &) const
| Returns the water vaporization factor [m^3/m^3] of the water phase.
template<class Evaluation = Scalar>
Evaluation | saturatedWaterVaporizationFactor (unsigned, const Evaluation &, const Evaluation &, const Evaluation &) const
| Returns the water vaporization factor [m^3/m^3] of water saturated gas.
template<class Evaluation>
Evaluation | saturatedOilVaporizationFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure) const
| Returns the oil vaporization factor [m^3/m^3] of the gas phase.
template<class Evaluation>
Evaluation | saturatedOilVaporizationFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &oilSaturation, const Evaluation &maxOilSaturation) const
| Returns the oil vaporization factor [m^3/m^3] of the gas phase.
template<class Evaluation>
Evaluation | saturationPressure (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure) const
| Returns the saturation pressure of the gas phase [Pa].
template<class Evaluation>
Evaluation | diffusionCoefficient (const Evaluation &temperature, const Evaluation &pressure, unsigned compIdx) const
const IsothermalPvt * | isoThermalPvt () const
Scalar | gasReferenceDensity (unsigned regionIdx) const
Scalar | hVap (unsigned regionIdx) const
const std::vector< TabulatedOneDFunction > & | gasvisctCurves () const
const std::vector< Scalar > & | viscrefPress () const
const std::vector< Scalar > & | viscRef () const
const std::vector< Scalar > & | gasdentRefTemp () const
const std::vector< Scalar > & | gasdentCT1 () const
const std::vector< Scalar > & | gasdentCT2 () const
const std::vector< TabulatedOneDFunction > & | internalEnergyCurves () const
bool | enableInternalEnergy () const
const std::vector< Scalar > & | gasJTRefPres () const
const std::vector< Scalar > & | gasJTC () const
bool | operator== (const GasPvtThermal< Scalar > &data) const
GasPvtThermal< Scalar > & | operator= (const GasPvtThermal< Scalar > &data)

## Detailed Description

template<class Scalar>
class Opm::GasPvtThermal< Scalar >

This class implements temperature dependence of the PVT properties of gas.

Note that this only implements the temperature part, i.e., it requires the isothermal properties as input.

## Member Function Documentation

## saturatedOilVaporizationFactor() [1/2]

template<class Scalar>
template<class Evaluation>

Evaluation Opm::GasPvtThermal< Scalar >::saturatedOilVaporizationFactor | ( | unsigned | regionIdx,
|  | const Evaluation & | temperature,
|  | const Evaluation & | pressure ) const

inline

Returns the oil vaporization factor [m^3/m^3] of the gas phase.

This method implements temperature dependence and requires the gas pressure, temperature and the oil saturation as inputs. Currently it is just a dummy method which passes through the isothermal oil vaporization factor.

## saturatedOilVaporizationFactor() [2/2]

template<class Scalar>
template<class Evaluation>

Evaluation Opm::GasPvtThermal< Scalar >::saturatedOilVaporizationFactor | ( | unsigned | regionIdx,
|  | const Evaluation & | temperature,
|  | const Evaluation & | pressure,
|  | const Evaluation & | oilSaturation,
|  | const Evaluation & | maxOilSaturation ) const

inline

Returns the oil vaporization factor [m^3/m^3] of the gas phase.

This method implements temperature dependence and requires the gas pressure, temperature and the oil saturation as inputs. Currently it is just a dummy method which passes through the isothermal oil vaporization factor.

## saturationPressure()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::GasPvtThermal< Scalar >::saturationPressure | ( | unsigned | regionIdx,
|  | const Evaluation & | temperature,
|  | const Evaluation & | pressure ) const

inline

Returns the saturation pressure of the gas phase [Pa].

This method implements temperature dependence and requires isothermal satuation pressure and temperature as inputs. Currently it is just a dummy method which passes through the isothermal saturation pressure.

The documentation for this class was generated from the following files:

- opm/material/fluidsystems/blackoilpvt/GasPvtThermal.hpp
- opm/material/fluidsystems/blackoilpvt/GasPvtThermal.cpp